package org.bbcorrector;

import net.rim.device.api.system.Bitmap;
import net.rim.device.api.ui.UiApplication;
import net.rim.device.api.ui.component.Dialog;

public class BusyDialog extends Dialog {

    BusyDialogWorkerThread worker = null;

    public BusyDialog(String message, BusyDialogWorkerThread worker) {
        super(message,
              null,
              null,
              0,
              Bitmap.getPredefinedBitmap(Bitmap.HOURGLASS));
        this.worker = worker;
    }

    public void display() {
        synchronized (UiApplication.getUiApplication().getAppEventLock()) {
            this.show();
        }
        worker.start();
        try {
            worker.join();
        } catch (InterruptedException e) {
        }
        synchronized (UiApplication.getUiApplication().getAppEventLock()) {
            this.close();
        }
    }
}
